diff -ur orig/libraries/clib/awt/X/fnt.c libraries/clib/awt/X/fnt.c
--- orig/libraries/clib/awt/X/fnt.c	Sun Mar  4 10:23:00 2001
+++ libraries/clib/awt/X/fnt.c	Sun Mar  4 10:23:40 2001
@@ -64,6 +64,8 @@
  * adapts the AWT to your X installation/preferences. Don't lament, modify it!
  */
 
+XOC create_xoc(Toolkit *X,char *font_name);
+
 void*
 Java_java_awt_Toolkit_fntInitFont ( JNIEnv* env, jclass clazz, jstring jSpec,
                                     jint style, jint size )
@@ -71,9 +73,9 @@
   int  i, j, k, i0, i1, j0, j1, di, dj;
   char buf[160];
   char *spec = java2CString( env, X, jSpec);
-  XFontStruct* fs = 0;
-
-	size *= 10;  /* convert into X pointsizes */
+  XOC xoc = NULL;
+  
+  size *= 10;  /* convert into X pointsizes */
 
   if ( style & 0x1 ) { /* we have a Font.BOLD request */
     i0 = NWEIGHT - 1; i1 = -1; di = -1;
@@ -89,35 +91,35 @@
     j0 = 0; j1 = NSLANT; dj = 1;
   }
 
-  for ( j=j0; !fs && (j != j1); j += dj ) {
-    for ( i=i0; !fs && (i != i1); i += di ) {
-      for ( k=0;  !fs && (k < NDSIZE); k++ ) {
+  for ( j=j0; (xoc == NULL) && (j != j1); j += dj ) {
+    for ( i=i0; (xoc == NULL) && (i != i1); i += di ) {
+      for ( k=0;  (xoc == NULL) && (k < NDSIZE); k++ ) {
         sprintf( buf, spec, weight[i], slant[j], size + dsize[k]);
         DBG( AWT_FNT, printf("look up font: %s\n", buf));
-        fs = XLoadQueryFont( X->dsp, buf);
+        xoc = create_xoc( X, buf);
       }
     }
   }
 
-  if ( ! fs ){
+  if ( ! xoc ){
     /* now we are getting desperate, try the spec directly (without vars) */
-    fs = XLoadQueryFont( X->dsp, spec);
+    xoc = create_xoc( X, spec);
   }
 
-  if ( ! fs ){
+  if ( ! xoc ){
 	DBG( AWT, printf("cannot load font: %s (backup to %s)\n", buf, backupFont));
-	if ( !(fs = XLoadQueryFont( X->dsp, backupFont)) ) {
+	if ( !(xoc = create_xoc( X, backupFont)) ) {
 	  fprintf( stderr, "font panic, no default font!\n");
 	}
   }
 
-  return (void*) fs;
+  return (void*) xoc;
 }
 
 void
-Java_java_awt_Toolkit_fntFreeFont ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntFreeFont ( JNIEnv* env, jclass clazz, XOC xoc )
 {
-  XFreeFont( X->dsp, fs);
+  XDestroyOC(xoc);
 }
 
 
@@ -126,92 +128,109 @@
  */
 
 void*
-Java_java_awt_Toolkit_fntInitFontMetrics ( JNIEnv* env, jclass clazz, void* fs )
+Java_java_awt_Toolkit_fntInitFontMetrics ( JNIEnv* env, jclass clazz, void* xoc )
 {
-  return fs;
+  return xoc;
 }
 
 void
-Java_java_awt_Toolkit_fntFreeFontMetrics ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntFreeFontMetrics ( JNIEnv* env, jclass clazz, XOC xoc )
 {
 }
 
 
 jint
-Java_java_awt_Toolkit_fntGetAscent ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetAscent ( JNIEnv* env, jclass clazz, XOC xoc )
 {
-  return fs->ascent;
+  DBG( AWT, printf("Java_java_awt_Toolkit_fntGetAscent=%d\n",-XExtentsOfFontSet(xoc)->max_logical_extent.y));
+  return -XExtentsOfFontSet(xoc)->max_logical_extent.y;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetDescent ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetDescent ( JNIEnv* env, jclass clazz, XOC xoc )
 {
-  return fs->descent;
+  XFontSetExtents *xfse=XExtentsOfFontSet(xoc);
+  return xfse->max_logical_extent.height-(-xfse->max_logical_extent.y); 
+  //  return fs->descent;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetFixedWidth ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetFixedWidth ( JNIEnv* env, jclass clazz, XOC xoc )
 {
-  return (fs->min_bounds.width == fs->max_bounds.width) ? fs->max_bounds.width : 0;
-}
+  return 0;
+  /*
+  XFontSetExtents *xfse=XExtentsOfFontSet(xoc);
+  return ( xfse->max_logical_extent.width == xfse->max_ink_extent.width ) ?
+    xfse->max_logical_extent.width : 
+    0;
+*/
+}  
 
 jint
-Java_java_awt_Toolkit_fntGetHeight ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetHeight ( JNIEnv* env, jclass clazz, XOC xoc )
 {
-  return fs->ascent + fs->descent +1;
+   DBG( AWT, printf("Java_java_awt_Toolkit_fntGetHeight=%d\n",XExtentsOfFontSet(xoc)->max_logical_extent.height));
+   return XExtentsOfFontSet(xoc)->max_logical_extent.height;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetLeading ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetLeading ( JNIEnv* env, jclass clazz, XOC xoc )
 {
   return 0;  /* no leading (interline spacing) for X fonts */
 }
 
 jint
-Java_java_awt_Toolkit_fntGetMaxAdvance ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetMaxAdvance ( JNIEnv* env, jclass clazz, XOC xoc )
 {
-  return fs->max_bounds.width;
+  return XExtentsOfFontSet(xoc)->max_logical_extent.width;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetMaxAscent ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetMaxAscent ( JNIEnv* env, jclass clazz, XOC xoc )
 {
-  return fs->max_bounds.ascent;
+  XFontSetExtents *xfse=XExtentsOfFontSet(xoc);
+  return -xfse->max_logical_extent.y;
 }
 
 jint
-Java_java_awt_Toolkit_fntGetMaxDescent ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetMaxDescent ( JNIEnv* env, jclass clazz, XOC xoc )
 {
-  return fs->max_bounds.descent;
+  XFontSetExtents *xfse=XExtentsOfFontSet(xoc);
+  return xfse->max_logical_extent.height-(-xfse->max_logical_extent.y); 
 }
 
 jboolean
-Java_java_awt_Toolkit_fntIsWideFont ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntIsWideFont ( JNIEnv* env, jclass clazz, XOC xoc )
 {
-  return (fs->min_byte1 | fs->max_byte1);
+  return 2;					     
 }
 
+
 jobject
-Java_java_awt_Toolkit_fntGetWidths ( JNIEnv* env, jclass clazz, XFontStruct* fs )
+Java_java_awt_Toolkit_fntGetWidths ( JNIEnv* env, jclass clazz, XOC xoc )
 {
-  int       n = 256;
   jintArray widths;
   jint      *jw;
   jboolean isCopy;
-  register  int i, j;
+  register  int i;
+  XRectangle ink_array, logical_array;
+  XRectangle overall_ink, overall_logical;
+  wchar_t wch;
+  int num;
+
+  DBG( AWT, printf("Java_java_awt_Toolkit_fntGetWidths\n"));
 
   widths = (*env)->NewIntArray( env, 256);
   jw = (*env)->GetIntArrayElements( env, widths, &isCopy);
 
-  if ( fs->max_char_or_byte2 < n ) n = fs->max_char_or_byte2;
-
-  if ( fs->min_bounds.width == fs->max_bounds.width ) {
-	for ( i=fs->min_char_or_byte2, j=0; i < n; i++, j++ )
-	  jw[i] = fs->max_bounds.width;
-  }
-  else {
-	for ( i=fs->min_char_or_byte2, j=0; i < n; i++, j++ )
-	  jw[i] = fs->per_char[j].width;
+  for( i = 0; i < 256; i++ ) {
+    wch = i;
+    if(!XwcTextPerCharExtents(xoc ,&wch ,1 ,&ink_array, &logical_array, 1,
+			  &num,&overall_ink, &overall_logical )){
+    fprintf(stderr, __FILE__ "(%d)"
+	    "):" "XwcTextPerCharExtents Error\n",__LINE__ );
+    }
+    jw[i] = overall_logical.width;
   }
 
   (*env)->ReleaseIntArrayElements( env, widths, jw, 0);
@@ -219,79 +238,154 @@
   return widths;
 }
 
-
 jint
 Java_java_awt_Toolkit_fntBytesWidth ( JNIEnv* env, jclass clazz,
-	XFontStruct* fs, jbyteArray jBytes, jint off, jint len )
+	XOC xoc, jbyteArray jBytes, jint off, jint len )
 {
   jboolean  isCopy;
   jbyte    *jb = (*env)->GetByteArrayElements( env, jBytes, &isCopy);
   int       n = (*env)->GetArrayLength( env, jBytes);
-  int       w;
+  wchar_t   *wch;
+  XRectangle *ink_array, *logical_array;
+  XRectangle overall_ink, overall_logical;
+  int num;
+
+  DBG( AWT,printf("Java_java_awt_Toolkit_fntBytesWidth\n"));
 
   if ( off+len > n ) len = n - off;
 
-  w = XTextWidth( fs, jb+off, len);
+  wch = jbyte2wchar( jb + off, len );
+  ink_array = (XRectangle *)malloc(sizeof(XRectangle)*len);
+  logical_array = (XRectangle *)malloc(sizeof(XRectangle)*len);
+
+  if(!XwcTextPerCharExtents(xoc ,wch ,len ,ink_array,logical_array, len,
+			&num,&overall_ink ,&overall_logical)){
+    fprintf(stderr, __FILE__ "(%d)"
+	    "):" "XwcTextPerCharExtents Error\n",__LINE__ );
+  }
+
+  free( (void *)logical_array );
+  free( (void *)ink_array );
+  free( (void *)wch );
 
   (*env)->ReleaseByteArrayElements( env, jBytes, jb, JNI_ABORT);
-  return w;
+  
+  return overall_logical.width;
 }
 
 jint
-Java_java_awt_Toolkit_fntCharWidth ( JNIEnv* env, jclass clazz, XFontStruct* fs, jchar jChar )
+Java_java_awt_Toolkit_fntCharWidth ( JNIEnv* env, jclass clazz, XOC xoc, jchar jChar )
 {
-#ifndef WORDS_BIGENDIAN
-  jChar = (jChar << 8) | (jChar >> 8);
-#endif
+    wchar_t wch;
+    XRectangle ink_array, logical_array;
+    XRectangle overall_ink, overall_logical;
+    int num;
+    
+    wch = jChar;
+    if(!XwcTextPerCharExtents(xoc ,&wch ,1 ,&ink_array, &logical_array,
+			  1,
+			  &num, &overall_ink, &overall_logical)){
+    fprintf(stderr, __FILE__ "(%d)"
+	    "):" "XwcTextPerCharExtents Error\n",__LINE__ );
+    }
 
-  return XTextWidth16( fs, (XChar2b*)&jChar, 1);
+    return overall_logical.width;
 }
 
 jint
 Java_java_awt_Toolkit_fntCharsWidth ( JNIEnv* env, jclass clazz,
-	XFontStruct* fs, jcharArray jChars, jint off, jint len )
+	XOC xoc, jcharArray jChars, jint off, jint len )
 {
   jboolean  isCopy;
   jchar    *jc = (*env)->GetCharArrayElements( env, jChars, &isCopy);
   int      n = (*env)->GetArrayLength( env, jChars);
-  XChar2b  *b;
-  int      w;
+  wchar_t  *wch;
+  XRectangle *ink_array, *logical_array;
+  XRectangle overall_ink, overall_logical;
+  int num;
+
+  DBG( AWT, printf("Java_java_awt_Toolkit_fntCharsWidth\n"));
 
   if ( off+len > n ) len = n - off;
 
-#ifndef WORDS_BIGENDIAN
-  n = sizeof(XChar2b)*len;
-  b = (XChar2b*) getBuffer( X, n);
-  swab( (jc+off), b, n);
-#else
-  b = (XChar2b*) (jc + off);
-#endif
+  wch = jchar2wchar( jc + off, len );
+  ink_array = (XRectangle *)malloc(sizeof(XRectangle)*len);
+  logical_array = (XRectangle *)malloc(sizeof(XRectangle)*len);
+
+  if(!XwcTextPerCharExtents(xoc ,wch ,len ,ink_array,logical_array, len,
+			   &num,&overall_ink ,&overall_logical)){
+    fprintf(stderr, __FILE__ "(%d)"
+	    "):" "XwcTextPerCharExtents Error\n",__LINE__ );
+  }
 
-  w = XTextWidth16( fs, b, len);
+  free( (void *)logical_array );
+  free( (void *)ink_array );
+  free( (void *)wch );
 
   (*env)->ReleaseCharArrayElements( env, jChars, jc, JNI_ABORT);
-  return w;
+  return overall_logical.width;
 }
 
+
 jint
-Java_java_awt_Toolkit_fntStringWidth ( JNIEnv* env, jclass clazz, XFontStruct* fs, jstring jStr )
+Java_java_awt_Toolkit_fntStringWidth ( JNIEnv* env, jclass clazz, XOC xoc, jstring jStr )
 {
   jboolean isCopy;
   const jchar    *jc = (*env)->GetStringChars( env, jStr, &isCopy);
   int      len = (*env)->GetStringLength( env, jStr);
-  int      w, n;
-  XChar2b  *b;
+  wchar_t  *wch;  
+  XRectangle *ink_array, *logical_array;
+  XRectangle overall_ink, overall_logical;
+  int num=len;
+  
+  wch = jchar2wchar( jc, len );
+  ink_array = (XRectangle *)malloc(sizeof(XRectangle)*len);
+  logical_array = (XRectangle *)malloc(sizeof(XRectangle)*len);
+
+  if(!XwcTextPerCharExtents(xoc ,wch ,len ,ink_array,logical_array, len,
+			    &num,&overall_ink ,&overall_logical)){
+    fprintf(stderr, __FILE__ "(%d)"
+	    "):" "XwcTextPerCharExtents Error\n",__LINE__ );
+  }
 
-#ifndef WORDS_BIGENDIAN
-  n = sizeof(XChar2b)*len;
-  b = (XChar2b*) getBuffer( X, n);
-  swab( jc, b, n);
-#else
-  b = (XChar2b*) jc;
-#endif
+  free( (void *)logical_array );
+  free( (void *)ink_array );
+  free( (void *)wch );
+ 
+  (*env)->ReleaseStringChars( env, jStr, jc);
 
-  w = XTextWidth16( fs, b, len);
+  return overall_logical.width;
+}
 
-  (*env)->ReleaseStringChars( env, jStr, jc);
-  return w;
+
+XOC create_xoc(Toolkit *X,char *font_name){
+  XOC xoc;
+  int i;
+  char **missing_list;
+  int missing_count;
+  char *def_string;
+
+  xoc = XCreateOC(X->xom,
+		 XNBaseFontName, font_name,
+		 NULL);
+  if (xoc) {
+    XGetOCValues(xoc, 
+		 XNMissingCharSet, &missing_count,
+		 XNRequiredCharSet, &missing_list,
+		 XNDefaultString, &def_string,
+		 NULL);
+    if( missing_count!=0 ){
+      fprintf(stderr, "missing list exists at %s.\n" ,font_name);
+      for (i = 0; i < missing_count; i++) {
+	fprintf(stderr, "missing list[%d]: %s\n", i, missing_list[i]);
+      }
+    }
+  } else {
+    fprintf(stderr, "XCreateOC error at %s.\n" ,font_name);
+  }
+  return xoc;
 }
+
+
+
+
diff -ur orig/libraries/clib/awt/X/gra.c libraries/clib/awt/X/gra.c
--- orig/libraries/clib/awt/X/gra.c	Sun Mar  4 10:23:00 2001
+++ libraries/clib/awt/X/gra.c	Sun Mar  4 10:23:40 2001
@@ -13,6 +13,7 @@
 typedef struct {
   GC        gc;
   Drawable  drw;
+  XOC       oc;
   int       fg;
   int       bg;
   char      xor;
@@ -40,7 +41,7 @@
   Drawable       drw;
   XGCValues      values;
   XRectangle     rect;
-  unsigned long  valueMask = GCForeground | GCBackground | GCFont | GCFunction;
+  unsigned long  valueMask = GCForeground | GCBackground | GCFunction;
 
   DBG( AWT_GRA, printf("initGraphics: %p (%p, %d) %d,%d  %d,%d - %d,%d  %p %x %x\n",
 				 gr, tgt,tgtType, xOff,yOff, xClip,yClip,wClip,hClip, fnt,fg,bg));
@@ -65,9 +66,10 @@
 
   values.foreground = fg;
   values.background = bg;
-  values.font       = ((XFontStruct*)fnt)->fid;
+
+/*  values.font       = ((XFontStruct*)fnt)->fid;*/
   values.function   = GXcopy;
-  
+ 
   if ( gr ) {
 	XChangeGC( X->dsp, gr->gc, valueMask, &values);
   }
@@ -90,6 +92,7 @@
   gr->x0   = xOff;
   gr->y0   = yOff;
   gr->xor  = 0;
+  gr->oc   = fnt;
 
   if ( blank ) {
 	XSetForeground( X->dsp, gr->gc, gr->bg);
@@ -148,6 +151,7 @@
   jboolean isCopy;
   int      n;
   jbyte    *jb, *jbo;
+  wchar_t *wch;
 
   if ( !jBytes ) return;
 
@@ -161,7 +165,11 @@
   if ( offset+len > n )
 	len = n - offset;
 
-  XDrawString( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, jbo, len);
+  wch = jbyte2wchar( jbo, len );
+
+  XwcDrawString( X->dsp, gr->drw, gr->oc, gr->gc, x+gr->x0, y+gr->y0, wch,len);
+
+  free((void*) wch);
 
   (*env)->ReleaseByteArrayElements( env, jBytes, jb, JNI_ABORT);
   XFLUSH( X, False);
@@ -175,7 +183,7 @@
   jboolean isCopy;
   int      n;
   jchar    *jc, *jco;
-  XChar2b  *b;
+  wchar_t *wch;
 
   if ( !jChars ) return;
 
@@ -189,15 +197,11 @@
   if ( offset+len > n )
 	len = n - offset;
 
-#ifndef WORDS_BIGENDIAN
-  n = sizeof(XChar2b)*len;
-  b = (XChar2b*) getBuffer( X, n);
-  swab( (void*)jco, (void*)b, n);
-#else
-  b = (XChar2b*) jco;
-#endif
+  wch = jchar2wchar( jco, len );
+
+  XwcDrawString( X->dsp, gr->drw, gr->oc, gr->gc, x+gr->x0, y+gr->y0, wch,len); 
 
-  XDrawString16( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, b, len);  
+  free((void*) wch);
 
   (*env)->ReleaseCharArrayElements( env, jChars, jc, JNI_ABORT);
   XFLUSH( X, False);
@@ -209,9 +213,9 @@
 									  Graphics* gr, jstring str, jint x, jint y )
 {
   jboolean     isCopy;
-  int          n, len;
+  int          len;
   const jchar  *jc;
-  XChar2b      *b;
+  wchar_t *wch;
 
   DBG( AWT_GRA, printf("drawString: %p  \"%s\"  %d,%d\n", gr, java2CString(env,X,str), x,y));
 
@@ -220,15 +224,10 @@
   len = (*env)->GetStringLength( env, str);
   jc = (*env)->GetStringChars( env, str, &isCopy);
 
-#ifndef WORDS_BIGENDIAN
-  n = sizeof(XChar2b)*len;
-  b = (XChar2b*) getBuffer( X, n);
-  swab( jc, b, n);
-#else
-  b = (XChar2b*) jc;
-#endif
 
-  XDrawString16( X->dsp, gr->drw, gr->gc, x+gr->x0, y+gr->y0, b, len);  
+  wch = jchar2wchar( jc, len );
+  XwcDrawString( X->dsp, gr->drw, gr->oc, gr->gc, x+gr->x0, y+gr->y0, wch,len);
+  free( (void *)wch );
 
   (*env)->ReleaseStringChars( env, str, jc);
   XFLUSH( X, False);
@@ -587,8 +586,7 @@
 Java_java_awt_Toolkit_graSetFont ( JNIEnv* env, jclass clazz, Graphics* gr, jobject fnt )
 {
   DBG( AWT_GRA, printf("setFont: %p, %p\n", gr, fnt));
-
-  XSetFont( X->dsp, gr->gc, ((XFontStruct*)fnt)->fid);
+  gr->oc=(XOC)fnt;
 }
 
 void
diff -ur orig/libraries/clib/awt/X/tlk.c libraries/clib/awt/X/tlk.c
--- orig/libraries/clib/awt/X/tlk.c	Sun Mar  4 10:23:00 2001
+++ libraries/clib/awt/X/tlk.c	Sun Mar  4 10:23:40 2001
@@ -13,6 +13,7 @@
 
 #include "toolkit.h"
 #include "tlkprops.h"
+#include "locale.h"
 
 /********************************************************************************
  * auxiliary functions
@@ -80,6 +81,12 @@
 Java_java_awt_Toolkit_tlkInit ( JNIEnv* env, jclass clazz, jstring name )
 {
   char    *dspName;
+  /* for X Output Method */
+  int i;
+  Bool direction;
+  Bool contextdrawing;
+  XOMCharSetList cslist;
+  XOMOrientation orientation;
 
   getBuffer(X, 128);
 
@@ -138,6 +145,28 @@
   WAKEUP           = XInternAtom( X->dsp, "WAKEUP", False);
   RETRY_FOCUS      = XInternAtom( X->dsp, "RETRY_FOCUS", False);
   FORWARD_FOCUS    = XInternAtom( X->dsp, "FORWARD_FOCUS", False);
+
+  /* Open  X Output Method */
+  setlocale(LC_ALL ,"");
+
+  X->xom = XOpenOM(X->dsp, NULL, NULL, NULL);
+  if (X->xom) {
+    DBG( AWT, printf("locale of XOM: %s\n", XLocaleOfOM(X->xom)));
+    XGetOMValues(X->xom,
+		 XNRequiredCharSet, &cslist,
+		 XNQueryOrientation, &orientation,
+		 XNDirectionalDependentDrawing, &direction
+		 ,
+		 XNContextualDrawing, &contextdrawing,
+		 NULL);
+    
+    /* We could create fontset list from these. */
+      for (i = 0; i < cslist.charset_count; i++) {
+	DBG( AWT, printf("needed charset[%d]: %s\n", i, cslist.charset_list[i]));
+      }
+  } else {
+    fprintf(stderr ,"XOpenOM error\n");
+  }
 
   return JNI_TRUE;
 }
diff -ur orig/libraries/clib/awt/X/toolkit.h libraries/clib/awt/X/toolkit.h
--- orig/libraries/clib/awt/X/toolkit.h	Sun Mar  4 10:23:00 2001
+++ libraries/clib/awt/X/toolkit.h	Sun Mar  4 10:23:40 2001
@@ -1,5 +1,5 @@
 /**
- * toolkit.h - 
+ * toolkith - 
  *
  * Copyright (c) 1998
  *      Transvirtual Technologies, Inc.  All rights reserved.
@@ -38,6 +38,13 @@
 
 #define	DBG_ACTION(A,B)
 
+#if !(HAVE_DECLARED_SWAB)
+/* 
+ * Some systems (Linux) do not declare swab in any standard header file
+ */
+extern void swab(const void *from, void *to, size_t n);
+#endif
+
 #ifdef HAVE_FCNTL_H
 #include <fcntl.h>
 #endif
@@ -189,6 +196,7 @@
   Window         focus;     /* this is the real focus, if it is in our process */
   Window         focusFwd;  /* this might be a (owned) window we forward the focus to */
   int            fwdIdx;    /* cached index of the focus forward window */
+  XOM            xom;       /* X Output Method */
 } Toolkit;
 
 
@@ -326,6 +334,20 @@
 	X->nBuf = nBytes;
   }
   return X->buf;
+}
+
+static __inline__ wchar_t* jchar2wchar( const jchar *jc, int len ) {
+  int i;
+  wchar_t *wch = (wchar_t *)malloc(sizeof(wchar_t)*len);
+  for( i=0; i < len; i++ ) wch[i] = jc[i];
+  return wch;
+}
+
+static __inline__ wchar_t* jbyte2wchar( jbyte *jc, int len ) {
+  int i;
+  wchar_t *wch = (wchar_t *)malloc(sizeof(wchar_t)*(len));
+  for( i=0; i < len; i++ ) wch[i] = jc[i];
+  return wch;
 }
 
